DreamboxObj.mobile = true;

DreamboxObj.dialog = function(text) {
	if (text == '') {
		// Close the dialog
		$.mobile.loading('hide');
	} else {
		 $.mobile.loading('show', {
			 text: '',
			 textVisible: true,
			 theme: 'a',
			 textonly: false,
			 html: '<span class="ui-icon ui-icon-loading"></span>' + text + '<span id="zaptimer"></span>'
		});
	}
};

DreamboxObj.showBouquet = function(bouquetObj) {
	var div = jQuery('<div>').attr({'data-role':'collapsible','data-filter':'true','data-theme':'b'});
	div.append(jQuery('<h3>').attr('id',bouquetObj.id).text(bouquetObj.name));
	div.append(jQuery('<p>'));
	DreamboxObj.bouquetsDiv.append(div);
};

DreamboxObj.showBouquets = function() {
	var tmp = DreamboxObj.bouquetsDiv;
	DreamboxObj.bouquetsDiv = jQuery('<div>').attr({'data-role':'collapsible-set','data-inset':'false'});
	tmp.append(DreamboxObj.bouquetsDiv);
	tmp = null;
	
	for(bouquetID in DreamboxObj.bouquets) {
		if (DreamboxObj.bouquets[bouquetID].id.substring(0,1) != '_') {
			DreamboxObj.showBouquet(DreamboxObj.bouquets[bouquetID]);
		}
	}
	jQuery(DreamboxObj.bouquetsDiv.children('div')[0]).attr('data-collapsed','false');
	DreamboxObj.bouquetsDiv.collapsibleset();
}

DreamboxObj.showAllChannels = function() {
	for(bouquetid in DreamboxObj.bouquets) {
		DreamboxObj.showChannels(bouquetid);
	}
};
	
DreamboxObj.showChannels = function(bouquetid) {
	jQuery('h3[id="' + bouquetid + '"] + div > p').append(jQuery('<div>').attr({'data-role':'collapsible-set','data-inset':'false'}));
	for(channelid in DreamboxObj.bouquets[bouquetid].channels) {
		DreamboxObj.showChannel(bouquetid,channelid);
	}
	jQuery('h3[id="' + bouquetid + '"] + div ul').listview();
	jQuery('h3[id="' + bouquetid + '"] + div > p div').collapsibleset();
};

DreamboxObj.showChannel	= function(bouquetid,channelid) {
	var channelObj = DreamboxObj.bouquets[bouquetid].channels[channelid];
	var channelDiv = jQuery('h3[id="' + bouquetid + '"] + div > p > div');
	var li = jQuery('<li>').attr({'class':'channel'});
	
	var currentMarker = jQuery('h3[id="' + bouquetid + '"] + div h3:last').attr('id');
	if (channelObj.type == 'marker') {
		var div = jQuery('<div>').attr({'data-role':'collapsible','data-filter':'true'});
		div.append(jQuery('<h3>').attr('id',channelObj.id).text(channelObj.name));
		div.append(jQuery('<ul>').attr({'data-role':'listview','data-filter':'true'}));
		channelDiv.append(div);
	} else {
		li.attr({'id':channelObj.id});
		var a = jQuery('<a>').attr({'href':'#'}).bind('click',function() {
			DreamboxObj.zap(jQuery(this).parents('li.channel').attr('id'));
		});
		a.append(jQuery('<h2>').text(channelObj.name));
		
		a.append(jQuery('<p>').attr({'class':'now'}));
		a.append(jQuery('<p>').attr({'class':'next'}));
		a.append(jQuery('<p>').attr({'class':'ui-li-aside'})
			.append(jQuery('<br>'))
			.append(jQuery('<br>'))
			.append(jQuery('<span>').attr({'class':'now'}))
			.append(jQuery('<br>'))
			.append(jQuery('<span>').attr({'class':'next'}))
		);
		li.append(a);
		jQuery('h3[id="' + currentMarker + '"] ~ ul').append(li);
	}
};

DreamboxObj.showRecordings = function() {
	if (DreamboxObj.bouquets['_recordings'].amount > 0) {
		jQuery('#recordings > div[data-role="content"]').append(jQuery('<ul>').attr({'data-role':'listview','data-autodividers':'true'}));
		for(recordingid in DreamboxObj.bouquets['_recordings'].channels) {
			DreamboxObj.showRecording(recordingid);
		}
	}
};
	
DreamboxObj.showRecording = function(recordingid) {
	var recordingObj = DreamboxObj.bouquets['_recordings'].channels[recordingid];
	var channelDiv = jQuery('#recordings div[data-role="content"] ul');
	var li = jQuery('<li>').attr({'class':'channel'});
	
	li.attr({'id':recordingObj.id});
	var a = jQuery('<a>').attr({'href':'#'}).bind('click',function() {
			DreamboxObj.zap(jQuery(this).parents('li.channel').attr('id'));
		});
	a.append(jQuery('<h2>').text(recordingObj.name));
	a.append(jQuery('<p>').html('<strong>' + dateFormat(new Date(recordingObj.start * 1000),'dd-mm-yyyy HH:MM') + '-' + dateFormat(new Date(recordingObj.stop * 1000),'HH:MM') + '</strong>, ' + durationFormat(recordingObj.duration) + ', ' + recordingObj.channel));
	li.append(a);
	channelDiv.append(li);
};

DreamboxObj.showMovies = function() {
	if (DreamboxObj.bouquets['_movies'].amount > 0) {
		jQuery('#movies div[data-role="content"]').append(jQuery('<ul>').attr({'data-role':'listview','data-autodividers':'true'}));
		for(movieid in DreamboxObj.bouquets['_movies'].channels) {
			DreamboxObj.showMovie(movieid);
		}
	}
};
	
DreamboxObj.showMovie = function(movieid) {
	var movieObj = DreamboxObj.bouquets['_movies'].channels[movieid];
	var channelDiv = jQuery('#movies div[data-role="content"] ul');
	var li = jQuery('<li>').attr({'class':'channel'});
	
	li.attr({'id':movieObj.id});
	var a = jQuery('<a>').attr({'href':'#'}).bind('click',function() {
			DreamboxObj.zap(jQuery(this).parents('li.channel').attr('id'));
		});
	a.append(jQuery('<h2>').text(movieObj.name));
	a.append(jQuery('<p>').html(durationFormat(movieObj.duration) + ', ' + sizeFormat(movieObj.filesize,2) + ', ' + bitrateFormat(movieObj.bitrate,2) + ',' + movieObj.resolution + ' px'));
	if (movieObj.languages.length > 0) {
		var languagesDiv = jQuery('<span>').attr('class','languages');
		for (var i = 0 ; i < movieObj.languages.length; i++) {
			languagesDiv.append(jQuery('<span>').attr('class','ui-li-count').text(movieObj.languages[i]));
		}
		a.append(languagesDiv);
	}
	li.append(a);		
	channelDiv.append(li);
};

DreamboxObj.showProgram = function(channelid,programObj) {
	var now = Math.round((new Date()).getTime() / 1000); // GMT timestamp
	var spanClass = (programObj.start < now && programObj.stop > now ? 'now' : 'next');
	
	jQuery("#channels li[id='" + channelid + "'] a p." + spanClass).text(programObj.name);
	jQuery("#channels li[id='" + channelid + "'] a p.ui-li-aside span." + spanClass).text(dateFormat(new Date(programObj.start * 1000),'HH:MM'));
}

DreamboxObj.play = function(url) {
	var channelObj = DreamboxObj.getChannel(DreamboxObj.activechannel);
	var link = jQuery('<a>').attr({'href':url,'title':'Watch ' + channelObj.name,'target':'_blank'}).text('Watch ' + channelObj.name + ' (iOS)');
	if (url != '' || channelObj != false) {
		if (url.substr(0,4) == 'rtsp') {
			link = jQuery('<a>').attr({'href':url,'title':'Watch ' + channelObj.name,'target':'_blank'}).text('Watch ' + channelObj.name + ' (RTSP)');
			jQuery('#rtsplink').append(jQuery('<br />'));
			jQuery('#rtsplink').append(link);
			//setTimeout(function() { jQuery('#rtsplink a').click(); } , 1000);
		} else {
			jQuery('#rtsplink').html(link);
			DreamboxObj.playJW(url);
		}
		//if (navigator.userAgent.toLowerCase().indexOf("android") > -1) {
			setTimeout(function() { jQuery('#rtsplink a:first-child').click(false); } , 1000);
		//}
	}
	clearTimeout(DreamboxObj.zapTimer);
	DreamboxObj.dialog('');
};

DreamboxObj.start = function() {
	DreamboxObj.dialog('');
	xajax_action('loadNowAndNextEPGData');
};

var addToHomeConfig = {
	autostart: false,
	startDelay: 0
};

jQuery(document).on( "pagehide", function( event ,data) {
	if (jQuery(data.nextPage).attr('id') == 'watch' && DreamboxObj.activechannel != '') {
		channelObj = DreamboxObj.getChannel(DreamboxObj.activechannel);
		DreamboxObj.dialog('Zapping to channel: ' + channelObj.name);
	} else if (jQuery(data.nextPage).attr('id') == 'about') {
		addToHome.show(true);
	}
}).on( "pageShow", function( event ,data) {
	if (jQuery(data.prevPage).attr('id') == 'watch') {
		DreamboxObj.play('');
	}
});